/*
Copyright (C) 1994-1998 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru/

Implementation of the algorithm described in  
E.B. Rudnyi. Statistical model of systematic errors: linear error model. Chemometrics and Intelligent Laboratory Systems. 1996, V. 34, N 1, p. 41-54. 

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*/

#ifndef _COMMON_H
#define _COMMON_H

#include <iostream.h>
#include <stdlib.h>

void warning(const char* txt);

using namespace::std;

class buffer
{
  char *buf;
  char *cur;
  size_t sz;

public:
  buffer(size_t size = 10240)
    {buf = new char[sz = size]; cur = buf; if (!buf) sz = 0;}
  ~buffer()
    {delete buf;}
  int free()
    {return sz - busy();}
  int busy()
    {return cur - buf;}
  void read(void* ptr)
    {memcpy(ptr, buf, busy()); cur = buf;}
  bool write(const void* ptr, size_t n = 1);
  void clear()
    {cur = buf;}
  char* ptr()
    {return buf;}
};

extern buffer Buffer;

#endif
