#ifndef __AUTO_PTR1_H
#define __AUTO_PTR1_H

template<class T>
class auto_ptr1 {
public:
explicit auto_ptr1(T *p = 0): pointee(p) {}

auto_ptr1(auto_ptr1& rhs): pointee(rhs.release()) {}
auto_ptr1(const auto_ptr1& rhs): pointee((const_cast<auto_ptr1&>(rhs)).release()) {}

~auto_ptr1() { delete pointee; }

auto_ptr1<T>& operator=(const auto_ptr1& rhs)
{
  if (this != &rhs) reset((const_cast<auto_ptr1&>(rhs)).release());
  return *this;
}

T& operator*() const { return *pointee; }

T* operator-> () const { return pointee; }

T* get() const { return pointee; }

T* release()
{
  T *oldPointee = pointee;
  pointee = 0;
  return oldPointee;
}

void reset(T *p = 0) { delete pointee; pointee = p; }

private:
T *pointee;
};

#endif
