/*
Copyright (C) 1996-1998 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru/

Software for paper 
E. B. Rudnyi, V. V. Kuzmenko, G. V. Voronin. Simultaneous assessment of the YBa2Cu6O6+z thermodynamics under the linear error model. J. Phys. Chem. Ref. Data, 1998, v. 27, N 5, p. 855-888.

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*/

#include "elem.h"
#include <iostream.h>
#include <ctype.h> // islower isupper

char elem::el_name[NELEMENTS][2] =
{ 0 , 0 ,'e', 0 ,'O', 0 ,'H', 0 ,'D', 0 ,'T', 0 ,'F', 0 ,'C','l','B','r','I', 0 ,
 'A','t','H','e','N','e','A','r','K','r','X','e','R','n','S', 0 ,'S','e','T','e',
 'P','o','N', 0 ,'P', 0 ,'A','s','S','b','B','i','C', 0 ,'S','i','G','e','S','n',
 'P','b','B', 0 ,'A','l','G','a','I','n','T','l','Z','n','C','d','H','g','C','u',
 'A','g','A','u','F','e','C','o','N','i','R','u','R','h','P','d','O','s','I','r',
 'P','t','M','n','T','c','R','e','C','r','M','o','W', 0 ,'V', 0 ,'N','b','T','a',
 'T','i','Z','r','H','f','S','c','Y', 0 ,'L','a','C','e','P','r','N','d','P','m',
 'S','m','E','u','G','d','T','b','D','y','H','o','E','r','T','m','Y','b','L','u',
 'A','c','T','h','P','a','U', 0 ,'N','p','P','u','A','m','C','m','B','k','C','f',
 'E','s','F','m','M','d','N','o','B','e','M','g','C','a','S','r','B','a','R','a',
 'L','i','N','a','K', 0 ,'R','b','C','s','F','r'};

float elem::el_mass[NELEMENTS] = {
// NEL
0,
// e,      O ,  H ,   D ,    T ,    F ,    Cl,    Br,     I ,   At,
5.485e-4,15.9994,1.0079,2.014,3.016,18.9984,35.453,79.904,126.904,210.,
// He,   Ne,     Ar,   Kr,   Xe,   Rn,   S ,  Se,  Te,   Po,
4.0026,20.179,39.948,83.80,131.30,222.,32.06,78.9,127.6,209.,
// N ,     P ,      As,     Sb,    Bi,     C ,    Si,    Ge,   Sn,    Pb,
14.0067,30.97376,74.9216,121.75,208.9804,12.011,28.0855,72.59,118.69,207.2,
// B ,   Al,     Ga,  In,     Tl,   Zn,   Cd,     Hg,    Cu,     Ag,
10.81,26.98154,69.72,114.82,204.37,65.38,112.41,200.59,63.546,107.868,
// Au,     Fe,     Co,   Ni,    Ru,     Rh,    Pd,   Os,    Ir,    Pt,
196.9665,55.847,58.9332,58.70,101.07,102.9055,106.4,190.2,192.22,195.09,
// Mn,  Tc,   Re,     Cr,   Mo,   W ,     V ,    Nb,     Ta,     Ti,
54.938,97.,186.207,51.996,95.94,183.85,50.9414,92.9064,180.9479,47.90,
// Zr,  Hf,    Sc,     Y ,      La,     Ce,     Pr,    Nd,   Pm,   Sm,
91.22,178.49,44.9559,88.9059,138.9055,140.12,140.9077,144.24,145.,150.4,
// Eu,    Gd,     Tb,     Dy,     Ho,     Er,     Tm,     Yb,   Lu,   Ac,
151.96, 157.25,158.9254,162.50,164.9304,167.26,168.9342,173.04,174.97,227.,
// Th,      Pa,       U ,   Np,     Pu, Am,  Cm,   Bk, Cf,  Es,
232.0381,231.0359,238.029,237.0482,244.,243.,247.,247.,251.,254.,
// Fm, Md, No,    Be,     Mg,   Ca,   Sr,   Ba,     Ra,     Li,
257.,258.,259.,9.01218,24.305,40.08,87.62,137.33,226.0254,6.941,
// Na,      K ,     Rb,     Cs,   Fr
22.98977,39.0983,85.4678,132.9054,223.};

istream& elem::read(istream &in) {
  el = NEL;
  if (!in) return in;
  if (!isupper(in.peek()) && in.peek() != 'e')
    return in;
  char name;
  in.get(name);
  int find = 0;
  for (int i = 1; i < NELEMENTS; i++) {
    if (name == el_name[i][0]) {
      if (el_name[i][1]) {
        if (el_name[i][1] == in.peek()) {
          el = (elements)i;
          in.ignore();
          return in;
        }
      }
      else {
        if (!islower(in.peek())) {
          el = (elements) i;
          return in;
        }
        else
          find = i;
      }
    }
  }
  if (find)
    el = (elements) find;
  else
    in.putback(name);
  return in;
}

