/*
Copyright (C) 1996-1998 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru/

Software for paper 
E. B. Rudnyi, V. V. Kuzmenko, G. V. Voronin. Simultaneous assessment of the YBa2Cu6O6+z thermodynamics under the linear error model. J. Phys. Chem. Ref. Data, 1998, v. 27, N 5, p. 855-888.

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*/

#ifndef __ELEM_H
#define __ELEM_H

#include <iostream.h>

using namespace::std;

const int NELEMENTS = 106;

class elem
{
public:
  enum elements {NEL, e , O , H , D , T , F , Cl, Br, I ,
                  At, He, Ne, Ar, Kr, Xe, Rn, S , Se, Te,
                  Po, N , P , As, Sb, Bi, C , Si, Ge, Sn,
                  Pb, B , Al, Ga, In, Tl, Zn, Cd, Hg, Cu,
                  Ag, Au, Fe, Co, Ni, Ru, Rh, Pd, Os, Ir,
                  Pt, Mn, Tc, Re, Cr, Mo, W , V , Nb, Ta,
                  Ti, Zr, Hf, Sc, Y , La, Ce, Pr, Nd, Pm,
                  Sm, Eu, Gd, Tb, Dy, Ho, Er, Tm, Yb, Lu,
                  Ac, Th, Pa, U , Np, Pu, Am, Cm, Bk, Cf,
                  Es, Fm, Md, No, Be, Mg, Ca, Sr, Ba, Ra,
                  Li, Na, K , Rb, Cs, Fr};

private:
  elements el;

  static char el_name[NELEMENTS][2];
  static float el_mass[NELEMENTS];

public:
  elem()
    {el = NEL;}
  elem(elements old)
    {el = old;}
  elem& operator=(elements old)
    {el = old; return *this;}
  elem(istream &in)
    {read(in);}
  istream& read(istream& in);
  ostream& write(ostream& out) const
  {
    if (!el) return out;
    out << elem::el_name[el][0];
    if (elem::el_name[el][1])
      out << elem::el_name[el][1];
    return out;
  }
  operator int() const
    {return el;}
  void clear()
    {el = NEL;}
  double mass() const
    {return el_mass[el];}
};

inline istream& operator>>(istream &in, elem &to)
{
  in >> ws;
  return to.read(in);
};

inline ostream& operator<<(ostream &out, const elem &old)
{
  return old.write(out);
};

#endif
