/*
Copyright (C) 1996-1998 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru/

Software for paper 
E. B. Rudnyi, V. V. Kuzmenko, G. V. Voronin. Simultaneous assessment of the YBa2Cu6O6+z thermodynamics under the linear error model. J. Phys. Chem. Ref. Data, 1998, v. 27, N 5, p. 855-888.

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*/

#include "general.h"
#include <math.h>

void token::read()
{
  char ch;
  in >> ch;
  assign(string(1, ch));
  if (ch == '<' || ch == '>' || ch == '=')
    return;
  while (in.peek() != EOF &&
         !isspace(in.peek()) &&
         in.peek() != '<' &&
         in.peek() != '>' &&
         in.peek() != '=')
  {
    in.get(ch);
    append(string(1, ch));
  }
}

istream& coefficient::read(istream &in)
{
  name = "";
  unknown = true;
  x = 0.;
  token current(in);
  current.compare("<");
  current.compare("v");
  current.compare("name");
  current.compare("=");
  name = current.get();
  current.compare("unknown");
  current.compare("=");
  in >> unknown;
  current.compare(">");
  in >> x;
  current.compare("<");
  current.compare("/v");
  current.compare(">");
  return in;
}

ostream& coefficient::write(ostream &out) const
{
  if (name.empty())
    throw xmsg("write: name is empty");
  out << "<v name=" << name << " unknown=" << unknown
      << "> " << x << " </v> ";
  return out;
}


