/*
Copyright (C) 1996-1998 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru/

Software for paper 
E. B. Rudnyi, V. V. Kuzmenko, G. V. Voronin. Simultaneous assessment of the YBa2Cu6O6+z thermodynamics under the linear error model. J. Phys. Chem. Ref. Data, 1998, v. 27, N 5, p. 855-888.

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*/

#ifndef __GENERAL_H
#define __GENERAL_H

#include <iostream.h>

#include "formula.h"

#include <vector.h>

typedef vector<double> vec_double;
typedef vector<string> vec_string;
typedef vector<formula> vec_formula;

class init
{
public:
  init()
  {
  }
};

// xmsg was an error class in Borland 
class xmsg : string
{
public:
	xmsg(const string &str) : string(str) {}
	string print() {return *this;}
};

class global
{
public:
  static double p;   // 1. by default
  static double step1;   // 10.*sqrt(DBL_EPSILON) by default
  static double step2;   // 10.*pow(DBL_EPSILON, 1./3.) by default
};

class token : public string
{
  istream &in;

public:
  token(istream &in) : in(in) {}
  void read();
  void compare(const string &old)
  {
    read();
    if (string::compare(old) != 0)
      throw xmsg("read: wrong token");
  }
  string& get()
  {
    read();
    return *this;
  }
};

class coefficient
{
public:
  double x;
  bool unknown;
  string name;

  coefficient() : x(0), unknown(true) {}
  ~coefficient() {}
  istream& read(istream &in);
  ostream& write(ostream &out) const;
};

inline istream& operator>> (istream &in, coefficient &to)
{
  return to.read(in);
}

inline ostream& operator<< (ostream &out, const coefficient &old)
{
  return old.write(out);
}

inline void destroy(coefficient**) {}

typedef vector<coefficient*> vec_coef_ptr;
typedef vector<coefficient> vec_coef;

/* does not work, conflict with ostream::operator<< and
                                istream::operator

template <class T>
istream& operator>>(istream &in, T &to)
{
  in >> ws;
  return to.read(in);
};

template <class T>
ostream& operator<<(ostream &out, const T &old)
{
  return old.write(out);
};
*/

#endif

